﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace cellwithbutton
{
    public partial class Form1 : Form
    {
        Form2 f2;
        SpreadLinkIconAndTextCellType ct;
        public Form1()
        {
            InitializeComponent();
            f2 = new Form2();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            ct = new SpreadLinkIconAndTextCellType();
            ct.ButtonClicked += new EventHandler(ct_ButtonClicked);
            ct.BackgroundColor = Color.White;
            ct.ForeColor = Color.Black;
            ct.LinkIcon = Image.FromFile(@"C:\Users\stduser\Desktop\image1.gif");
            fpSpread1.Sheets[0].Cells[1, 1].CellType = ct;
        }
        void ct_ButtonClicked(object sender, EventArgs e)
        {
           f2.Show();
            
        }
    }
    class SpreadLinkIconAndTextCellType : FarPoint.Win.Spread.CellType.GeneralCellType
    {
        private Image linkIcon;
        private Color backgroundColor;
        private Color foreColor;
        private FarPoint.Win.ButtonElement buttonElement = new FarPoint.Win.ButtonElement();
        private string text;
        private Rectangle _btnRect;

        public Image LinkIcon
        {
            get { return linkIcon; }
            set { linkIcon = value; }
        }

        public Color BackgroundColor
        {
            get { return backgroundColor; }
            set { backgroundColor = value; }
        }

        public Color ForeColor
        {
            get { return foreColor; }
            set { foreColor = value; }
        }

        public FarPoint.Win.ButtonElement ButtonElement
        {
            get { return buttonElement; }
            set { buttonElement = value; }
        }
        
        public string Text
        {
            get { return text; }
            set { text = value; }
        }

        public Rectangle btnRect
        {
            get { return _btnRect; }
            set { _btnRect = value; }
        }
        public event EventHandler ButtonClicked;
        protected FarPoint.Win.InputTextBox tb;
        private bool flag;
        
        public override Control GetEditorControl(FarPoint.Win.Spread.Appearance appearance, float zoomFactor)
        {
            FarPoint.Win.FpButton b = new FarPoint.Win.FpButton();
            b.Picture = LinkIcon;
            b.Click += new EventHandler(b_Click);
            b.MouseMove += new MouseEventHandler(b_MouseMove);
            b.MouseLeave += new EventHandler(b_MouseLeave);
            Control ctrl = base.GetEditorControl(appearance, zoomFactor);
            tb = (FarPoint.Win.InputTextBox)ctrl.Controls[0];
            tb.Resize += new EventHandler(tb_Resize);
            
            ctrl.Controls.Add(b);
            b.Visible = true;
            b.Location = new Point(0, 0);
            b.Size = new Size(btnRect.Width, btnRect.Height);
            return ctrl;
        }

        public override object IsReservedLocation(Graphics g, int x, int y, Rectangle rc, FarPoint.Win.Spread.Appearance appearance, object value, float zoomFactor)
        {
            if (btnRect.Contains(new Point(x, y)))
            {
                if (Control.MouseButtons == MouseButtons.Left)
                {
                    b_Click(this, EventArgs.Empty);
                    return null;
                }
                return this;
            }
            return null;
        }

        public override void PaintCell(Graphics g, Rectangle r, FarPoint.Win.Spread.Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
        {
            Brush backColorBrush = new SolidBrush(backgroundColor);
            Brush foreColorBrush = new SolidBrush(foreColor);
            g.FillRectangle(backColorBrush, r);
            if ((this.Text != "") && (this.Text != null))
            {
              g.DrawString(this.Text, appearance.Font, foreColorBrush, new RectangleF(r.X + this.linkIcon.Width, r.Y, r.Width - this.linkIcon.Width, r.Height));
            }
            backColorBrush.Dispose();
            foreColorBrush.Dispose();
            
            btnRect = new Rectangle(r.X, r.Y, this.linkIcon.Width, this.linkIcon.Height);
            buttonElement.Border = new FarPoint.Win.BevelBorder(FarPoint.Win.BevelBorderType.Raised, SystemColors.ControlLightLight, SystemColors.ControlDark, 1);
            buttonElement.ForegroundImage = new FarPoint.Win.Picture(this.linkIcon, FarPoint.Win.RenderStyle.StretchAndScale, Color.Magenta, FarPoint.Win.HorizontalAlignment.Center, FarPoint.Win.VerticalAlignment.Center);
            buttonElement.OnPaintBackground(g, btnRect);
            buttonElement.OnPaint(g, btnRect);
        }

        public override object GetEditorValue()
        {
            if (base.GetEditorValue() != null)
                this.Text = base.GetEditorValue().ToString();
            else
                this.Text = null;

            return base.GetEditorValue();
        }
        public override void SetEditorValue(object value)
        {
            if ((value != null) && value.ToString() == this.text)
            {
                base.SetEditorValue(value);
            }
            else
            {
                base.SetEditorValue(this.Text);
            }

        }

        private void tb_Resize(object sender, EventArgs e)
        {
            if (!flag)
            {
                flag = true;
                tb.Size = new Size(tb.Width - btnRect.Width, tb.Height);
                tb.Location = new Point(btnRect.Width + 3, 0);
                flag = false;
            }

        }

        private void b_Click(object sender, EventArgs e)
        {
            if (ButtonClicked != null)
                ButtonClicked(this, EventArgs.Empty);
        }

        private void b_MouseLeave(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.Default;
        }
        
        private void b_MouseMove(object sender, MouseEventArgs e)
        {
            Cursor.Current = Cursors.Arrow;
        }
    }
}
